{
HInweise:
1)Modified event for fkINternalcalc in:
   dataset.inc
   procedure TDataSet.DataEvent(Event: TDataEvent; Info: Ptrint);

         procedure HandleFieldChange(aField: TField);
         begin
           if aField.FieldKind in [fkData, fkInternalCalc] then
             SetModified(True);

}
unit sqldbempmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, sqldb, db, FileUtil, Forms, Controls,
  Graphics, Dialogs, ComCtrls, DbCtrls, DBGrids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    IBConnection1: TIBConnection;
    Memo1: TMemo;
    SQLQuery1: TSQLQuery;
    SQLQuery1CONTACT_FIRST: TStringField;
    SQLQuery1CUSTOMER: TStringField;
    SQLQuery1CUST_NO: TLongintField;
    SQLQuery1MYFIELD: TLongintField;
    SQLTransaction1: TSQLTransaction;
    ToolBar1: TToolBar;
    BtnApplyUpdates: TToolButton;
    BtnDbConnected: TToolButton;
    BtnUpdateStatus: TToolButton;
    procedure BtnApplyUpdatesClick(Sender: TObject);
    procedure BtnDbConnectedClick(Sender: TObject);
    procedure BtnUpdateStatusClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
    procedure DbConnect;
    procedure DbDisConnect;
    function AddMyField(ADataset: TDataset; AFieldClass: TFieldClass;  AFieldName: string; AFieldSize: integer): TField;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  DbConnect;
  BtnDbConnected.Down:=true;
  Memo1.Lines.Add(SQLQuery1.FieldByName('MYFIELD').FieldNo.ToString);
  //Memo1.Lines.Add(SQLQuery1.FieldByName('CALCFLD1').FieldNo.ToString);

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DbDisConnect;
end;

procedure TForm1.BtnApplyUpdatesClick(Sender: TObject);
begin
  SQLQuery1.ApplyUpdates;
  SQLTransaction1.CommitRetaining; //dont close after commit
end;

procedure TForm1.DbConnect;
begin
  IBConnection1.Connected:=True;
  SQLTransaction1.Active:=True;
  //does not work: AddMyField(SQLQuery1,TIntegerField,'MYFIELD',0);
  SQLQuery1.Active:=True;
end;

procedure TForm1.DbDisConnect;
begin
  SQLQuery1.Active:=False;
  SQLTransaction1.Active:=False;
  IBConnection1.Connected:=False;
end;

procedure TForm1.BtnDbConnectedClick(Sender: TObject);
begin
  if IBConnection1.Connected then DbDisConnect
  else DbConnect;
  BtnDbConnected.Down:=IBConnection1.Connected;
end;

procedure TForm1.BtnUpdateStatusClick(Sender: TObject);
var s: string;
begin

  s:='';
  if SQLQuery1.Modified then s:=s+'SQLQuery.Modified';
  if usUnmodified = SQLQuery1.UpdateStatus then s:=s+'usUnmodified';
  if usModified = SQLQuery1.UpdateStatus then s:=s+'usModified';
  if usInserted = SQLQuery1.UpdateStatus then s:=s+'usInserted';
  if usDeleted = SQLQuery1.UpdateStatus then s:=s+'usDeleted';

  Memo1.Lines.Add(TimeToStr(now)+' Updatestatus: '+s);//IntToStr(SQLQuery1.UpdateStatus));
end;

function TForm1.AddMyField(ADataset: TDataset; AFieldClass: TFieldClass;  AFieldName: string; AFieldSize: integer): TField;
var
  i: Integer;
begin
  //I have this from:
  //https://stackoverflow.com/questions/25549220/create-a-fkinternalcalc-field-on-tsqlquery
  if ADataset.FieldDefs.Count = 0 then begin
    ADataset.FieldDefs.Update;

   ADataset.Open;
   ADataset.FieldDefs.Update;
   ADataset.Close;

    for i := 0 to ADataset.FieldDefs.Count - 1 do
      ADataset.FieldDefs[i].CreateField(ADataset);
  end;

  Result := ADataset.FindField(AFieldName);

  if Result <> nil then  exit;

  Result := AFieldClass.Create(ADataset);
  Result.FieldName := AFieldName;
  Result.FieldKind := fkInternalCalc;
  Result.DataSet := ADataset;

  if AFieldSize>0 then  Result.Size := AFieldSize;
end;

end.
